#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m, i, x, y, ct, start;
vector <int> a[10001];
int used[10001];
int p[10001];
int b[10001][10001];

void bfs (int s)
{
    int x, k, i;
    queue <int> q;
    used[s] = 1;
    q.push (s);
    while (!q.empty())
    {
        int br = 0;
        x = q.front ();
        q.pop ();
        k = a[x].size ();
        for( i=0; i<=k-1; i++ )
        {
            if( used[a[x][i]] == 0 )
            {
                used[a[x][i]] = 1;
                q.push(a[x][i]);
            }
            if( p[a[x][i]] == 1 ) br ++;
        }
        if( p[x] != 1 ) p[x] = k - br;
    }
}

void scan ()
{
    scanf ("%d%d", &n, &m);
    for( i=1; i<=m; i++ )
    {
        scanf ("%d%d", &x, &y);
        a[x].push_back (y);
        a[y].push_back (x);
    }
}

void find_start ()
{
    for( i=1; i<=n; i++ )
        if( a[i].size () == 1 )
        {
            p[i] = 1;
            start = i;
            break;
        }
    for( i=start+1; i<=n; i++ )
        if( a[i].size () == 1 ) p[i] = 1;
}

void solve ()
{
   for( i=1; i<=n; i++ )
        if( p[i] == 1 ) ct ++;
    printf ("%d\n", n - ct);
}

int main ()
{
    scan ();
    find_start ();
    bfs (start);
    solve ();
}
