/*
PROG:park
LANG:C++
*/
#include <iostream>
#include <stdio.h>
#include <vector>
using namespace std;

vector<int> g[16384];
int n;
long long m;
int prev[16384];
bool used[16384];

void print(int s,int finish)
{
     int sol=0;
     while(s!=finish)
     {
                     sol++;
                     s=prev[s];
     }
     cout << sol+1 << endl;
}

void dfs(int v,int pred)
{
     used[v]=1;
     for(int i=0;i<g[v].size();i++)
     {
             if(used[g[v][i]] && g[v][i]!=pred) { print(v,g[v][i]); exit(0); }
             if(!used[g[v][i]]) { prev[g[v][i]]=v; dfs(g[v][i],v); }
     }
}

int main()
{
    cin >> n >> m;
    for(;m;m--)
    {
               int x,y;
               scanf("%d %d",&x,&y);
               g[x].push_back(y);
               g[y].push_back(x);
    }
    for(int i=1;i<=n;i++)
     if(!used[i])
     {
                 prev[i]=-1;
                 dfs(i,0);
     }

    return 0;
}
