/*
PROG:flood
LANG:C++
*/
#include <iostream>
#include <stdio.h>
#include <queue>
#include <vector>
#include <cmath>
using namespace std;

int m,n;
int a[1024][1024];
long long v;

template <class T>
class cmp
{
      public:
             bool operator()(T a,T b) const
             {
                  return a>b;
             }
};

priority_queue<long long, vector<long long>, cmp<long long> > q;

int main()
{
    cin >> m >> n >> v;
    for(int i=0;i<m;i++)
     for(int j=0;j<n;j++)
     {
             scanf("%d",&a[i][j]);
             q.push(a[i][j]);
     }
    double sol;
    while(v>0)
    {
                     long long mn=q.top(); int br=0;
                     while(!q.empty() && q.top()==mn) { br++; q.pop(); }
                     //cout << mn << " " << br << endl;
                     if(q.empty())
                     {
                                  printf("%.2lf 100.00\n",(double)mn+(double)v/(double)br);
                                  return 0;
                     }
                     long long x=q.top();
                     if(v>(x-mn)*br)
                     {
                                    for(int i=0;i<br;i++) q.push(x);
                                    v-=(x-mn)*br;
                     }
                     else
                     {
                         sol=(double)mn+(double)v/(double)br;
                         v=0;
                     }
    }
    int cnt=0;
    for(int i=0;i<m;i++)
     for(int j=0;j<n;j++)
      if(sol>=(double)a[i][j]) cnt++;
    
    printf("%.2lf %.2lf\n",sol,(double)(cnt*100)/(double)(m*n));

    return 0;
}
