#include <cstdio>
#include <queue>
#include <vector>
#include <stack>
using namespace std;
vector<int> neig[10000];
int used[10000];
bool used_edge[10000][10000];
int ans[10000];
int n;
int m;
int bfs(int start) {
    queue<int> que;
    que.push(start);
    int cur, size;
    while (!que.empty()) {
        cur = que.front();
        size = neig[cur].size();
        for (unsigned i = 0;i < size; ++i) {
            if (!used[neig[cur][i]]) {
                que.push(neig[cur][i]);
                used[neig[cur][i]] = 1;
                used_edge[cur][neig[cur][i]] = 1;
                used_edge[neig[cur][i]][cur] = 1;
            } else if (!used_edge[cur][neig[cur][i]]) {
                return cur;
            }
        }
        que.pop();
    }
    return 0;
}
void dfs(int start) {
    stack<int> st;
    st.push(start);
    for (int i = 0;i < n; ++i) used[i] = 0;
    int top, cur, size;
    bool use;
    ans[start] = 1;
    used[start] = 1;
    while (!st.empty()) {
        top = st.top();
        size = neig[top].size();
        use = 1;
        unsigned i;
        for (i = 0;i < size && use; ++i) {
            use = used[neig[top][i]];
        }
        i--;
        if (use) st.pop();
        else {
            st.push(neig[top][i]);
            ans[neig[top][i]] = ans[top] + 1;
            used[neig[top][i]] = 1;
        }
    }
}
int main() {
    scanf("%d %d", &n, &m);
    int v1, v2;
    for (int i = 0;i < m; ++i) {
        scanf("%d %d", &v1, &v2);
        v1--;
        v2--;
        neig[v1].push_back(v2);
        neig[v2].push_back(v1);
    }
    int res = bfs(0);
    dfs(res);
    int a = 0;
    for (unsigned i = 0;i < neig[res].size(); ++i) {
        if (ans[a] < ans[neig[res][i]]) a = neig[res][i];
    }
    printf("%d\n", ans[a]);
    return 0;
}
